typedef struct Samply Samply;
typedef struct Image Image;
typedef struct State State;

struct Samply {
	Image *tx; /* this is a pointer to one of the images below */

	Image *idle;
	Image *walka;
	Image *walkb;
};

struct Image {
	char *name; /* used for debugging purposes */
	int w;
	int h;
	int bpp;
	unsigned char *data;
	SDL_Surface *sur;
	SDL_Texture *tex;
};

struct State {
	SDL_Window *win;
	SDL_Renderer *ren;
	SDL_DisplayID dpy;
	SDL_Rect bounds;
	Uint64 lastframe;

	Samply *sam;
};
